<?php
// ------------------------------------------------------------------------- //
// Coppermine Photo Gallery 1.3.2                                            //
// ------------------------------------------------------------------------- //
// Copyright (C) 2002-2004 Gregory DEMAR                                     //
// http://www.chezgreg.net/coppermine/                                       //
// ------------------------------------------------------------------------- //
// Updated by the Coppermine Dev Team                                        //
// (http://coppermine.sf.net/team/)                                          //
// see /docs/credits.html for details                                        //
// ------------------------------------------------------------------------- //
// This program is free software; you can redistribute it and/or modify      //
// it under the terms of the GNU General Public License as published by      //
// the Free Software Foundation; either version 2 of the License, or         //
// (at your option) any later version.                                       //
// ------------------------------------------------------------------------- //
// CVS version: $Id: exif_php.inc.php,v 1.6 2004/07/24 15:04:09 gaugau Exp $
// ------------------------------------------------------------------------- //

define("EXIF_CACHE_FILE","exif.dat");
require("include/exifReader.inc.php");

function exif_parse_file($filename)
{        global $CONFIG;
        if (!is_readable($filename)) return false;
        $size = @getimagesize($filename);
        if ($size[2] != 2) return false; // Not a JPEG file

        //Check if we have the data of the said file in the table
        $sql = "SELECT * FROM {$CONFIG['TABLE_EXIF']} ".
                  "WHERE filename = \"$filename\"";

        $result = db_query($sql);

        if (mysql_num_rows($result)){
                $row = mysql_fetch_array($result);
                mysql_free_result($result);
                $exifParsed = unserialize($row["exifData"]);
                return $exifParsed;
        }

        // No data in the table - read it from the image file
        $exifObj = new phpExifReader($filename);
        $exif = $exifObj->getImageInfo();

        $exifParsed = array();
// Translate EXIF strings to more sensical information
// Put longer substrings before shorter ones, else the shorter ones will override
	$exFrom = array('isoEquiv','fnumber','exifComment', 'exposureTime','exposureMode','exposureBias','DateTime','meteringMode','flashUsed','flength35mm','whiteBalanceAuto','whiteBalance','distanceRange', 'zoomRatio','subjectArea','make','exposure','brightness','sceneType','jpegQuality');
	$exTo   = array('ISO', 'Exposure F-Stop','Comment', 'Exposure Shutter Speed', 'Exposure Auto/Manual', 'Exposure Bias (+/- ev)', 'Date Taken','Metering Mode','Flash Used','Zoom Optical (35mm equiv)','White Balance Mode','White Balance','Lens Focus (general)','Zoom Digital (ratio, 0-nx)','Subject Area', 'make','Camera Mode','Brightness','Digital Camera','JPEG Mode');
	$exIgnore = '/\A('.$CONFIG['exif_ignore1'].$CONFIG['exif_ignore2'].$CONFIG['exif_ignore3'].')\z/';
	
function exGetVals( $str ) {
	return preg_split('/[(),]+/',$str,-1,PREG_SPLIT_NO_EMPTY);
}
function exGetParenVal( $str ) {
	if (preg_match( '@\((.*)\)@', $str, $matches ) ) {
		return $matches[1];
	}
	return "";
}
	
	$exClean = array();
        foreach ($exif as $key=>$val) {
        	$origkey=$key;
        	$val = trim($val);	// always trim
        	$key = preg_replace($exIgnore,'ignoreit',$key);
        	$key = str_replace($exFrom,$exTo,$key);
        	$exClean[$key]=$val;
        }
        
        foreach ($exClean as $key=>$val) {
        	switch ($key) {
        	case 'White Balance Mode':
        		if (!isset($exClean['White Balance'])) {
	        		$exifParsed[$key] = $val; // default of inclusion
        		}
        		break;
        	case 'focalLength':
        		if (!isset($exClean['Zoom Optical (35mm equiv)'])) {
        			//we need this version
        			$vArray = exGetVals( $val );
        			$val = $vArray[0]; // first approximation
        			if (isset($exClean['CCDWidth'])) {
        				// can calculate it
        				$val = (int)(($val/$exClean['CCDWidth'])*36 + 0.5);
        				$val .= 'mm';
        			} else {
        				$val .= ' (percent?)';
        			}
        			$exifParsed['Zoom Optical (35mm equiv)'] = $val;
        		}
        		break;
        	case 'model':
        	case 'CCDWidth':
        	case 'software':
        	case 'ignoreit': 
        		break;
        	case 'Zoom Optical (35mm equiv)':
        		$exifParsed[$key] = $val.'mm';
        		break;

        	case 'Subject Area':
        		$vArray = exGetVals( $val );
        		if ($vArray[0] != 0.0) {
        	       		$exifParsed[$key] = $val; // There's something there
        	       	}
        	       	break;
        	case 'White Balance':
        		if (isset($exClean['White Balance Mode'])) {
        				$val = trim($exClean['White Balance Mode']).' '.$val;
        		}
        		$exifParsed[$key] = $val; // default of inclusion
        		break;
        	case 'Digital Camera': $val = ($val != 0)? "Yes" : "No"; break;
        	case 'make':	if (isset($exClean['model'])) {
        				$val .= ' - '.trim($exClean['model']);
        			}
        			if (isset($exClean['software'])) {
        				$val .= ' (sw: '.trim($exClean['software']).')';
                		}
	        		$exifParsed['Camera'] = $val; // default of inclusion
        			break;
        	// Display only the first value
        	//
        	case 'Brightness':
        	case 'Zoom Digital (ratio, 0-nx)':
        	case 'Exposure Bias (+/- ev)':
        		$vArray = exGetVals( $val );
        		if ($vArray[0] != 0) {
				$exifParsed[$key] = $vArray[0];	// Just the first number
			}
			break;        		
        	//
        	// Display only the value in parentheses
        	//
        	case 'Exposure Shutter Speed':
        		$vArray = exGetVals( $val );
        		$ct = count($vArray);
        		$val = $vArray[$ct-1];
        		//drop through to default
        	default: 
        		$exifParsed[$key] = $val; // default of inclusion
        	}
        }
        
if (0) { // Obsolete
        $Make = isset($exif['make']);
        $Model = isset($exif['model']);

        if (isset($exif['make']) && isset($exif['model'])){
                $exifParsed['Camera'] = trim($exif['make'])." - ".trim($exif['model']);
        }

        if (isset($exif['DateTime'])){
                $exifParsed['DateTaken'] = $exif['DateTime'];
        }

        if (isset($exif['fnumber'])){
                $exifParsed['Aperture'] = $exif['fnumber'];
        }

        if (isset($exif['exposureTime'])){
                $exifParsed['ExposureTime'] = $exif['exposureTime'];
        }

        if (isset($exif['focalLength'])){
                $exifParsed['FocalLength'] = $exif['focalLength'];
        }

        if (isset($exif['isoEquiv'])){
                $exifParsed['ISO'] = $exif['isoEquiv'];
        }

        if (isset($exif['exifComment'])){
                $comment = $exif['exifComment'];
                $exifParsed['Comment'] = $comment; // eregi_replace("ASCII"," ", $comment);
        }

}
	ksort( $exifParsed );	// Display in alpha order
	reset( $exifParsed );
        // Insert it into table for future reference
        $sql = "INSERT INTO {$CONFIG['TABLE_EXIF']} ".
                  "VALUES ('".addslashes($filename)."', '".addslashes(serialize($exifParsed))."')";
        $result = db_query($sql);

        return $exifParsed;
}
?>
